<template>
    <div class="q-pa-md row q-gutter-md">

        <q-card flat class="bg-grey-3">
            <q-bar>
                <q-icon name="perm_identity" color="blue-grey-8" />
                <q-space />
                <div class="text-h6 text-center text-blue-grey-8">Users</div>
                <q-space />
                <q-btn dense flat color="primary" icon="edit" @click="dialogCreateUser = true" />
            </q-bar>
            <q-card-section>
                <q-btn round  icon="add" color="primary" @click="dialogCreateUser = true" class="shadow-12"></q-btn>
            </q-card-section>
            <q-card-section>
                <div class="q-pa-md row items-start q-gutter-md">
                    <user-card v-for="user in users" :userData="user" :key="user.username"></user-card>
                </div>
            </q-card-section>
        </q-card>



        <q-dialog v-model="dialogCreateUser" :maximized="maximizedCreateUserToggle" transition-show="slide-up" transition-hide="slide-down" persistent >
            <q-card>
                <q-bar>
                    <q-space />
                    <div class="text-h6 text-blue-grey-8">Create User</div>
                    <q-space />
                    <q-btn dense flat icon="minimize" @click="maximizedCreateUserToggle = false" :disable="!maximizedCreateUserToggle" >
                        <q-tooltip v-if="maximizedCreateUserToggle" content-class="bg-white text-primary" >Minimize</q-tooltip>
                    </q-btn>
                    <q-btn dense flat icon="crop_square" @click="maximizedCreateUserToggle = true" :disable="maximizedCreateUserToggle" >
                        <q-tooltip v-if="!maximizedCreateUserToggle" content-class="bg-white text-primary">Maximize</q-tooltip>
                    </q-btn>
                    <q-btn dense flat icon="close" v-close-popup >
                        <q-tooltip content-class="bg-white text-primary" >Close</q-tooltip>
                    </q-btn>
                </q-bar>

                <q-card-section>
                    <q-card flat >
                        <q-form  @submit="createUser()" >
                            <q-card-section>
                                <div class="text-h6 text-blue-grey-8">User Informations</div>
                            </q-card-section>
                            <q-card-section>
                                <div class="q-gutter-lg">
                                    <q-input type="text" v-model="user.username" label="Username" lazy-rules :rules="[ val => val && val.length > 0 || 'Please type something']" />
                                    <q-input filled :type="isPwd ? 'password' : 'text'" v-model="user.password" label="Your password *" hint="Password" lazy-rules :rules="[ val => val && val.length > 0 || 'Please type something']" >
                                        <template v-slot:append>
                                            <q-icon :name="isPwd ? 'visibility_off' : 'visibility'" class="cursor-pointer" @click="isPwd = !isPwd" />
                                        </template>
                                    </q-input>
                                    <q-input type="email" v-model="user.email" label="Email" lazy-rules :rules="[ val => val && val.length > 0 || 'Please type something']" />
                                    <q-input type="text" v-model="user.firstName" label="First Name" lazy-rules :rules="[ val => val && val.length > 0 || 'Please type something']"/>
                                    <q-input type="text" v-model="user.lastName" label="Last Name" lazy-rules :rules="[ val => val && val.length > 0 || 'Please type something']"/>
                                    <q-input type="text" v-model="user.organization" label="Organization" lazy-rules :rules="[ val => val && val.length > 0 || 'Please type something']"/>
                                    <q-input type="text" v-model="user.status" label="Status" lazy-rules :rules="[ val => val && val.length > 0 || 'Please type something']"/>
                                    <q-input type="number" v-model="user.age" label="Age" lazy-rules :rules="[ val => val && val.length > 0 || 'Please type something']"/>
                                    <q-select v-model="user.gender" :options="genders" label="Gender" lazy-rules :rules="[ val => val && val.length > 0 || 'Please type something']"/>
                                    <q-select dense v-model="user.roles" :options="roles" multiple filled lazy-rules label="Roles & Rights" :rules="[ val => val && val.length > 0 || 'Please type something']"/>
                                </div>
                            </q-card-section>
                            <q-card-actions align="right">
                                <q-btn label="Create User" type="submit" icon="save" color="primary" :loading="savingModifs" v-close-popup/>
                            </q-card-actions>
                        </q-form>
                    </q-card>
                </q-card-section>
            </q-card>
        </q-dialog>


    </div>
</template>

<script>
import api from '../boot/backend-api';
import Store from '../store/index';
import UserCard from '../components/UserCard';
export default {
    components: {
        UserCard
    },
    name: 'admin',
    data() {
        return {
            users: [],
            user: {  username: '', password: '', firstName: '', lastName: '', age: null, gender: '', email: '', organization: '', status: '', avatar: '', roles: [] },
            genders: ['male', 'female'],
            roles: ['GUEST_USER', 'STANDARD_USER', 'ADMIN_USER',],
            isPwd: true,
            avatarKey: 0,
            dialogCreateUser: false,
            maximizedCreateUserToggle: true,
            savingModifs: false,
            alerts: { 'saved': { color: 'positive', message: 'User created' } }
        }
    },
    mounted () {
        this.getUsers();
        this.$root.$on('componentAdmin', () => {
            // allow access by other component
            this.getUsers()
        });
    },
    methods: {
        createUser(){
            api.createUser(this.user)
            .then(response => {
                this.showNotif('top-right', 'saved');
                this.getUsers();
            })
        },
        getUsers(){
            api.requestUsers().then( response => {
                this.users = response.data;
            }).catch( error => {console.log(error);});
        },
        showNotif (position, alert) {
            const { color, textColor, multiLine, icon, message, avatar, actions } = this.alerts[alert];
            const buttonColor = color ? 'white' : void 0;
            this.$q.notify({
                color,
                textColor,
                icon: icon,
                message,
                position,
                avatar,
                multiLine,
                actions: actions,
                timeout: 2000
            })
        }
    }
}
</script>

<style lang="stylus" scoped>

</style>
